import React from "react";
import { View, StyleSheet } from "react-native";

type Props = {
  Component: React.ElementType;
  onLayout: (LayoutChangeEvent) => void;
  componentProps?: Record<any, any>;
  containerStyle?: Record<string, any>;
};

const styles = StyleSheet.create({
  container: {
    position: "absolute",
    opacity: 0,
  },
});

const _MeasurementsPortal = (
  { Component, onLayout, componentProps, containerStyle }: Props,
  ref
) => (
  <View
    onLayout={onLayout}
    style={[styles.container, containerStyle]}
    ref={ref}
  >
    <Component {...componentProps} />
  </View>
);

export const MeasurementsPortal = React.forwardRef(_MeasurementsPortal);
